Debian Bug report logs - #663916
RFS: phonetisaurus/0.6-1 [ITP] -- Grapheme to Phoneme conversion tool

Package: sponsorship-requests; Maintainer for sponsorship-requests is Debian Mentors <package-sponsorship-requests@lists.debian.org>;

Reported by: Giulio Paci <giuliopaci@gmail.com>

Date: Wed, 14 Mar 2012 21:31:41 UTC

Owned by: Jakub Wilk <jwilk@debian.org>

Severity: wishlist

Done: Jakub Wilk <jwilk@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Information forwarded to debian-bugs-dist@lists.debian.org, Debian Mentors <debian-mentors@lists.debian.org>:
Bug#663916; Package sponsorship-requests. (Wed, 14 Mar 2012 21:31:44 GMT) Full text and rfc822 format available.

Acknowledgement sent to Giulio Paci <giuliopaci@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Mentors <debian-mentors@lists.debian.org>. (Wed, 14 Mar 2012 21:31:44 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Giulio Paci <giuliopaci@gmail.com>
To: submit@bugs.debian.org
Subject: RFS: phonetisaurus/0.1-1 [ITP] -- Grapheme to Phoneme conversion tool
Date: Wed, 14 Mar 2012 00:04:46 +0100
Package: sponsorship-requests
  Severity: wishlist

  Dear mentors,

  I am looking for a sponsor for my package "phonetisaurus"

 * Package name    : phonetisaurus
   Version         : 0.1-1
   Upstream Author : Josef Novak <josef.robert.novak@gmail.com>
 * URL             : http://code.google.com/p/phonetisaurus/
 * License         : GPL-3+
   Section         : misc


  It builds those binary packages:

    phonetisaurus - Grapheme to Phoneme conversion tool

  To access further information about this package, please visit the
following URL:

  http://mentors.debian.net/package/phonetisaurus


  Alternatively, one can download the package with dget using this command:

    dget -x
http://mentors.debian.net/debian/pool/main/p/phonetisaurus/phonetisaurus_0.1-1.dsc

  Regards,
   Giulio Paci




Severity set to 'wishlist' from 'normal' Request was from Paul Tagliamonte <tag@pault.ag> to control@bugs.debian.org. (Sat, 24 Mar 2012 20:15:04 GMT) Full text and rfc822 format available.

Added indication that bug 663916 blocks 663643 Request was from Ansgar Burchardt <ansgar@43-1.org> to control@bugs.debian.org. (Tue, 27 Mar 2012 08:39:22 GMT) Full text and rfc822 format available.

Changed Bug title to 'RFS: phonetisaurus/0.4-1 [ITP] -- Grapheme to Phoneme conversion tool' from 'RFS: phonetisaurus/0.1-1 [ITP] -- Grapheme to Phoneme conversion tool' Request was from Bart Martens <bartm@quantz.debian.org> to control@bugs.debian.org. (Sun, 24 Jun 2012 06:24:03 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Mentors <debian-mentors@lists.debian.org>:
Bug#663916; Package sponsorship-requests. (Thu, 19 Jul 2012 05:27:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Bart Martens <bartm@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Mentors <debian-mentors@lists.debian.org>. (Thu, 19 Jul 2012 05:27:05 GMT) Full text and rfc822 format available.

Message #16 received at 663916@bugs.debian.org (full text, mbox):

From: Bart Martens <bartm@debian.org>
To: Giulio Paci <giuliopaci@gmail.com>, 663916@bugs.debian.org
Subject: RFS: phonetisaurus
Date: Thu, 19 Jul 2012 05:23:52 +0000
Hi Giulio,

I see that you updated the package at mentors around 24 June 2012, but the
package is no longer there.  What happened ?

Regards,

Bart Martens



Owner recorded as Jakub Wilk <jwilk@debian.org>. Request was from Jakub Wilk <jwilk@debian.org> to control@bugs.debian.org. (Thu, 19 Jul 2012 07:15:09 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Mentors <debian-mentors@lists.debian.org>, Jakub Wilk <jwilk@debian.org>:
Bug#663916; Package sponsorship-requests. (Thu, 19 Jul 2012 09:51:08 GMT) Full text and rfc822 format available.

Acknowledgement sent to Giulio Paci <giuliopaci@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Mentors <debian-mentors@lists.debian.org>, Jakub Wilk <jwilk@debian.org>. (Thu, 19 Jul 2012 09:51:08 GMT) Full text and rfc822 format available.

Message #23 received at 663916@bugs.debian.org (full text, mbox):

From: Giulio Paci <giuliopaci@gmail.com>
To: Bart Martens <bartm@debian.org>
Cc: 663916@bugs.debian.org
Subject: Re: RFS: phonetisaurus
Date: Thu, 19 Jul 2012 11:51:14 +0200
Hi Bart!

On 19/07/2012 07:23, Bart Martens wrote:
> I see that you updated the package at mentors around 24 June 2012, but the
> package is no longer there.  What happened ?


It happened that I contacted Jakub Wilk that is wishing to review and to
sponsor both openfst and phonetisaurus. I published the git repositories
on collab-maint and we are using them to keep track of the latest
updates (openfst packages expecially are big and it would be a waste of
time and resources to upload them on mentors).

The latest version of phonetisaurus is available at:
git://git.debian.org/git/collab-maint/phonetisaurus.git

You can browse sources at:
http://anonscm.debian.org/gitweb/?p=collab-maint/phonetisaurus.git

Bests,
	Giulio.



Changed Bug title to 'RFS: phonetisaurus/0.5-1 [ITP] -- Grapheme to Phoneme conversion tool' from 'RFS: phonetisaurus/0.4-1 [ITP] -- Grapheme to Phoneme conversion tool' Request was from Giulio Paci <giuliopaci@gmail.com> to control@bugs.debian.org. (Tue, 09 Oct 2012 00:12:03 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Mentors <debian-mentors@lists.debian.org>, Jakub Wilk <jwilk@debian.org>:
Bug#663916; Package sponsorship-requests. (Tue, 09 Oct 2012 00:21:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Giulio Paci <giuliopaci@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Mentors <debian-mentors@lists.debian.org>, Jakub Wilk <jwilk@debian.org>. (Tue, 09 Oct 2012 00:21:03 GMT) Full text and rfc822 format available.

Message #30 received at 663916@bugs.debian.org (full text, mbox):

From: Giulio Paci <giuliopaci@gmail.com>
To: 663916@bugs.debian.org
Subject: New phonetisaurus package available
Date: Tue, 09 Oct 2012 02:16:43 +0200
Hi Jakub!
	Finally a new upstream release of phonetisaurus came out with the pending issues solved (i.e., non-free data files have been dropped, the only remaining script does not
have an extension).
I just updated the Debian package on git://git.debian.org/git/collab-maint/phonetisaurus.git.

Could you have a look at it?

Bests,
	Giulio.



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Mentors <debian-mentors@lists.debian.org>:
Bug#663916; Package sponsorship-requests. (Wed, 10 Oct 2012 21:03:05 GMT) Full text and rfc822 format available.

Message #33 received at 663916@bugs.debian.org (full text, mbox):

From: Jakub Wilk <jwilk@debian.org>
To: 663916@bugs.debian.org
Subject: Re: Bug#663916: New phonetisaurus package available
Date: Wed, 10 Oct 2012 22:59:41 +0200
* Giulio Paci <giuliopaci@gmail.com>, 2012-10-09, 02:16:
>git://git.debian.org/git/collab-maint/phonetisaurus.git.

The ugly hack in debian/rules is indeed ugly. :)

Could you split it into multiple lines? 410 characters is really too 
long.

Why is the filename between two -e expressions?

Last but not least, why do you need to recover this file? It looks like 
it shouldn't have been included in the upstream tarball in the first 
place.

Oh, and Google sparse hash implemented is already packaged in Debian. 
Please build-depend on libsparsehash-dev and make sure that the 
system-wide copy is used, not the bundled one.

Packaging the UTF-8 library (currently in src/3rdparty/utf8/) might be 
also worth considering, in order to comply with Policy §4.13.

-- 
Jakub Wilk



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Mentors <debian-mentors@lists.debian.org>, Jakub Wilk <jwilk@debian.org>:
Bug#663916; Package sponsorship-requests. (Thu, 11 Oct 2012 01:57:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Giulio Paci <giuliopaci@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Mentors <debian-mentors@lists.debian.org>, Jakub Wilk <jwilk@debian.org>. (Thu, 11 Oct 2012 01:57:03 GMT) Full text and rfc822 format available.

Message #38 received at 663916@bugs.debian.org (full text, mbox):

From: Giulio Paci <giuliopaci@gmail.com>
To: Jakub Wilk <jwilk@debian.org>, 663916@bugs.debian.org
Subject: Re: Bug#663916: New phonetisaurus package available
Date: Thu, 11 Oct 2012 03:52:50 +0200
Il 10/10/2012 22:59, Jakub Wilk ha scritto:
> * Giulio Paci <giuliopaci@gmail.com>, 2012-10-09, 02:16:
>> git://git.debian.org/git/collab-maint/phonetisaurus.git.
> 
> The ugly hack in debian/rules is indeed ugly. :)

I definitively agree.
I found a cleaner way to do that and applied it (by setting DEB_CLEAN_EXCLUDE in debian/rules).

> Last but not least, why do you need to recover this file? It looks like it shouldn't have been included in the upstream tarball in the first place.

Just because it was in the original tarball and I want that a "debian/rules clean" results in the same content of the original tarball.
I already contacted the author and the file will go away with next releases (and so the ugly hack).

> Oh, and Google sparse hash implemented is already packaged in Debian. Please build-depend on libsparsehash-dev and make sure that the system-wide copy is used, not the
> bundled one.
> 
> Packaging the UTF-8 library (currently in src/3rdparty/utf8/) might be also worth considering, in order to comply with Policy §4.13.

As we are not talking about shared libraries, but about a few headers files, I do not understand the benefits of doing so.
I see only disadvantages:
1) using system wide files will prevent me to easily know the source code used to compile the phonetisaurus debian package;
2) fixes in sparsehash will not be available to phonetisaurus unless phonetisaurus is recompiled;
3) I will need to maintain patches to use the system-wide copy;
4) an additional dependency is introduced;
5) If I will package UTF-8 I will need to invest time maintaining a new package that I do not care about and that contains just 4 headers files.

Do you think that policy §4.13 apply in this case? I seems to me that it is more related to shared libraries than static ones and headers.
Moreover I think that the last part of the following sentence applies:
"Debian packages should not make use of these convenience copies unless the included package is explicitly intended to be used in this way".

Bests,
	Giulio.



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Mentors <debian-mentors@lists.debian.org>:
Bug#663916; Package sponsorship-requests. (Fri, 12 Oct 2012 22:06:03 GMT) Full text and rfc822 format available.

Message #41 received at 663916@bugs.debian.org (full text, mbox):

From: Jakub Wilk <jwilk@debian.org>
To: 663916@bugs.debian.org
Subject: Re: Bug#663916: New phonetisaurus package available
Date: Sat, 13 Oct 2012 00:02:07 +0200
* Giulio Paci <giuliopaci@gmail.com>, 2012-10-11, 03:52:
>>>git://git.debian.org/git/collab-maint/phonetisaurus.git.
>>The ugly hack in debian/rules is indeed ugly. :)
>I definitively agree.
>I found a cleaner way to do that and applied it (by setting 
>DEB_CLEAN_EXCLUDE in debian/rules).

Much better, thanks. :)

>>Last but not least, why do you need to recover this file? It looks 
>>like it shouldn't have been included in the upstream tarball in the 
>>first place.
>Just because it was in the original tarball and I want that a 
>"debian/rules clean" results in the same content of the original 
>tarball.

Now I seem to recall that you told me that your workflow depends on such 
restoration. Sorry for the noise.

>I already contacted the author and the file will go away with next 
>releases (and so the ugly hack).

Great, thanks.

>>Oh, and Google sparse hash implemented is already packaged in Debian. 
>>Please build-depend on libsparsehash-dev and make sure that the 
>>system-wide copy is used, not the bundled one.
>>
>>Packaging the UTF-8 library (currently in src/3rdparty/utf8/) might be 
>>also worth considering, in order to comply with Policy §4.13.
>
>As we are not talking about shared libraries, but about a few headers 
>files, I do not understand the benefits of doing so.

The main benefit is the same: you can fix bugs in one place, instead of 
doing it N places (where N is usually >> 1).

>I see only disadvantages:
>1) using system wide files will prevent me to easily know the source 
>code used to compile the phonetisaurus debian package;

Convince upstream not to include them in the tarball and they will 
magically stop being part of the source. </semi-kiddingly>

(Sometimes we need to keep exact source for license reasons; that's what 
Built-Using field is for. This reminded me that I should review the 
copyright file; see below.)

>2) fixes in sparsehash will not be available to phonetisaurus unless 
>phonetisaurus is recompiled;

That's not worse than status quo. Also: binNMUs are cheap.

>3) I will need to maintain patches to use the system-wide copy;
>4) an additional dependency is introduced;

Again, convince upstream to drop the embedded copy, and these problems 
will go away. :)

>5) If I will package UTF-8 I will need to invest time maintaining a new 
>package that I do not care about and that contains just 4 headers 
>files.

I checked that there are at least 14 source packages in Debian that 
bundle UTF8-CPP:

drizzle fife gdcm gource librime libvoikko love md5deep megaglest 
mkvtoolnix paraview ruby-passenger supertuxkart vtk

Hopefully one of their maintainers would be interested in packaging it 
separately. Maybe file an RFP, CCing them all?

>Do you think that policy §4.13 apply in this case? I seems to me that 
>it is more related to shared libraries than static ones and headers.

No, §4.13 it's not only about shared library. It does apply here.

>Moreover I think that the last part of the following sentence applies:
>"Debian packages should not make use of these convenience copies unless 
>the included package is explicitly intended to be used in this way".

Do you have any evidence that this is the case (e.g. links to upstream 
documentation saying this is the preferred way of using the libraries)?

FWIW, I'm personally not fond of this exception to §4.13. I think we 
would be better without it. Fixing autotools bugs is definitely not fun.


Now the promised review of d/copyright:

>Files: *
>Copyright: 2011-2012, Josef Robert Novak
>License: GPL-3+

As far as I can see, the code has been relicensed to 2-clause BSD.

>Files: debian/phonetisaurus-g2p.1

No such file or directory.

>Files: FstPathFinder.cpp FstPathFinder.hpp
>Copyright: Chris Taylor
> 2011, Josef Novak
>License: Apache-2.0 and GPL-3+

These now contain 2-clause BSD headers, though README.md says the "code 
was licensed under the Apache license". Could you clarify this with 
upstream?

Copyright/license information for src/3rdparty/google/ is missing.

-- 
Jakub Wilk



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Mentors <debian-mentors@lists.debian.org>, Jakub Wilk <jwilk@debian.org>:
Bug#663916; Package sponsorship-requests. (Sat, 13 Oct 2012 13:57:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Giulio Paci <giuliopaci@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Mentors <debian-mentors@lists.debian.org>, Jakub Wilk <jwilk@debian.org>. (Sat, 13 Oct 2012 13:57:04 GMT) Full text and rfc822 format available.

Message #46 received at 663916@bugs.debian.org (full text, mbox):

From: Giulio Paci <giuliopaci@gmail.com>
To: 663916@bugs.debian.org
Subject: Re: Bug#663916: New phonetisaurus package available
Date: Sat, 13 Oct 2012 15:54:04 +0200
Hi!
	Thank you for your review.

Il 13/10/2012 00:02, Jakub Wilk ha scritto:
> * Giulio Paci <giuliopaci@gmail.com>, 2012-10-11, 03:52:
>>>> git://git.debian.org/git/collab-maint/phonetisaurus.git.

>>> Last but not least, why do you need to recover this file? It looks like it shouldn't have been included in the upstream tarball in the first place.
>> Just because it was in the original tarball and I want that a "debian/rules clean" results in the same content of the original tarball.
> 
> Now I seem to recall that you told me that your workflow depends on such restoration. Sorry for the noise.

No problem.

>>> Oh, and Google sparse hash implemented is already packaged in Debian. Please build-depend on libsparsehash-dev and make sure that the system-wide copy is used, not the
>>> bundled one.
>>>
>>> Packaging the UTF-8 library (currently in src/3rdparty/utf8/) might be also worth considering, in order to comply with Policy §4.13.
>>
>> As we are not talking about shared libraries, but about a few headers files, I do not understand the benefits of doing so.
> 
> The main benefit is the same: you can fix bugs in one place, instead of doing it N places (where N is usually >> 1).

Yes, I understand the goal, but I am worried that using external source code would make it harder to replicate possible issues (I will need the exact version of the
libsparsehash-dev binary package that was used to compile the library).
However this is probably true for many other C++ libraries. It is just more evident here, where the libraries are just simple header files.

>> I see only disadvantages:
>> 1) using system wide files will prevent me to easily know the source code used to compile the phonetisaurus debian package;
> (Sometimes we need to keep exact source for license reasons; that's what Built-Using field is for.)

How can I set Built-Using field? Should I set it by hand? Is it possible to set it automatically?

>> 2) fixes in sparsehash will not be available to phonetisaurus unless phonetisaurus is recompiled;
> 
> That's not worse than status quo. Also: binNMUs are cheap.

Maybe I am missing something in the upload process (well, I am missing almost everything to be honest).
Can you point some reference that will help me understanding what will happen when new releases of libsparsehash-dev will be released (and phonetisaurus will need
recompilation)?

>> 3) I will need to maintain patches to use the system-wide copy;

Created, applied and forwarded a patch for this.

>> 4) an additional dependency is introduced;
> 
> Again, convince upstream to drop the embedded copy, and these problems will go away. :)

Additional dependency introduced. :-) If the patch will be accepted upstream, the patch will let upstream to compile embedded copy of the libraries and us to compile using
the system-wide dependency.

>> 5) If I will package UTF-8 I will need to invest time maintaining a new package that I do not care about and that contains just 4 headers files.
> 
> I checked that there are at least 14 source packages in Debian that bundle UTF8-CPP:
> 
> drizzle fife gdcm gource librime libvoikko love md5deep megaglest mkvtoolnix paraview ruby-passenger supertuxkart vtk
> 
> Hopefully one of their maintainers would be interested in packaging it separately. Maybe file an RFP, CCing them all?

If you think it is useful, I will do this. However I would like to understand how I am supposed to deal with this kind of libraries before doing this.
With the patch above, it will be very easy to use the system-wide utfcpp library once it is packaged.

>> Do you think that policy §4.13 apply in this case? I seems to me that it is more related to shared libraries than static ones and headers.
> 
> No, §4.13 it's not only about shared library. It does apply here.

Ok, using libsparsehash-dev then.

>> Moreover I think that the last part of the following sentence applies:
>> "Debian packages should not make use of these convenience copies unless the included package is explicitly intended to be used in this way".
> 
> Do you have any evidence that this is the case (e.g. links to upstream documentation saying this is the preferred way of using the libraries)?

No, I have no evidence about it, but the documentation is scarce in this sense. Both libraries report something like:
"You just need to put the .h files somewhere your compiler can see this."
I just thought that sparsehash and utf8 are similar enough to gnulib that people would use them in the same way.

> FWIW, I'm personally not fond of this exception to §4.13. I think we would be better without it. Fixing autotools bugs is definitely not fun.

I see your point of view.
But not being able to understand if autotools files are not working on others' systems because of different version of tools or because problems in the environment is also
not fun. :-)

> Now the promised review of d/copyright:
> 
>> Files: *
>> Copyright: 2011-2012, Josef Robert Novak
>> License: GPL-3+
> 
> As far as I can see, the code has been relicensed to 2-clause BSD.

Right, fixed.

>> Files: debian/phonetisaurus-g2p.1
> 
> No such file or directory.

Also fixed.

>> Files: FstPathFinder.cpp FstPathFinder.hpp
>> Copyright: Chris Taylor
>> 2011, Josef Novak
>> License: Apache-2.0 and GPL-3+
> 
> These now contain 2-clause BSD headers, though README.md says the "code was licensed under the Apache license". Could you clarify this with upstream?

This code is partially covered by Apache 2.0 license and partially by the BSD-2-clause license.
Upstream tried to contact Chris Taylor in the past, but he was not able to talk to him.
He is thinking about rewriting these files from scratch.

> Copyright/license information for src/3rdparty/google/ is missing.

Added.

Bests,
	Giulio.



Changed Bug title to 'RFS: phonetisaurus/0.6-1 [ITP] -- Grapheme to Phoneme conversion tool' from 'RFS: phonetisaurus/0.5-1 [ITP] -- Grapheme to Phoneme conversion tool' Request was from Giulio Paci <giuliopaci@gmail.com> to control@bugs.debian.org. (Mon, 15 Oct 2012 19:39:03 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Mentors <debian-mentors@lists.debian.org>, Jakub Wilk <jwilk@debian.org>:
Bug#663916; Package sponsorship-requests. (Mon, 15 Oct 2012 19:51:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Giulio Paci <giuliopaci@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Mentors <debian-mentors@lists.debian.org>, Jakub Wilk <jwilk@debian.org>. (Mon, 15 Oct 2012 19:51:03 GMT) Full text and rfc822 format available.

Message #53 received at 663916@bugs.debian.org (full text, mbox):

From: Giulio Paci <giuliopaci@gmail.com>
To: 663916@bugs.debian.org
Subject: Re: Bug#663916: New phonetisaurus package available
Date: Mon, 15 Oct 2012 21:47:51 +0200
Hi!
	There has been a new phonetisaurus release (0.6).

All the patches have been applied upstream, the backup file in sparsehash has been removed, FstPathFinder.* have been rewritten from scratch.

I updated the Debian package files accordingly. All the phonetisaurus files have a BSD-2-clause header, but the README.txt reports BSD-3-clause. I will ask upstream about this.

Bests,
	Giulio.

Il 13/10/2012 15:54, Giulio Paci ha scritto:
> Hi!
> 	Thank you for your review.
> 
> Il 13/10/2012 00:02, Jakub Wilk ha scritto:
>> * Giulio Paci <giuliopaci@gmail.com>, 2012-10-11, 03:52:
>>>>> git://git.debian.org/git/collab-maint/phonetisaurus.git.
> 
>>>> Last but not least, why do you need to recover this file? It looks like it shouldn't have been included in the upstream tarball in the first place.
>>> Just because it was in the original tarball and I want that a "debian/rules clean" results in the same content of the original tarball.
>>
>> Now I seem to recall that you told me that your workflow depends on such restoration. Sorry for the noise.
> 
> No problem.
> 
>>>> Oh, and Google sparse hash implemented is already packaged in Debian. Please build-depend on libsparsehash-dev and make sure that the system-wide copy is used, not the
>>>> bundled one.
>>>>
>>>> Packaging the UTF-8 library (currently in src/3rdparty/utf8/) might be also worth considering, in order to comply with Policy §4.13.
>>>
>>> As we are not talking about shared libraries, but about a few headers files, I do not understand the benefits of doing so.
>>
>> The main benefit is the same: you can fix bugs in one place, instead of doing it N places (where N is usually >> 1).
> 
> Yes, I understand the goal, but I am worried that using external source code would make it harder to replicate possible issues (I will need the exact version of the
> libsparsehash-dev binary package that was used to compile the library).
> However this is probably true for many other C++ libraries. It is just more evident here, where the libraries are just simple header files.
> 
>>> I see only disadvantages:
>>> 1) using system wide files will prevent me to easily know the source code used to compile the phonetisaurus debian package;
>> (Sometimes we need to keep exact source for license reasons; that's what Built-Using field is for.)
> 
> How can I set Built-Using field? Should I set it by hand? Is it possible to set it automatically?
> 
>>> 2) fixes in sparsehash will not be available to phonetisaurus unless phonetisaurus is recompiled;
>>
>> That's not worse than status quo. Also: binNMUs are cheap.
> 
> Maybe I am missing something in the upload process (well, I am missing almost everything to be honest).
> Can you point some reference that will help me understanding what will happen when new releases of libsparsehash-dev will be released (and phonetisaurus will need
> recompilation)?
> 
>>> 3) I will need to maintain patches to use the system-wide copy;
> 
> Created, applied and forwarded a patch for this.
> 
>>> 4) an additional dependency is introduced;
>>
>> Again, convince upstream to drop the embedded copy, and these problems will go away. :)
> 
> Additional dependency introduced. :-) If the patch will be accepted upstream, the patch will let upstream to compile embedded copy of the libraries and us to compile using
> the system-wide dependency.
> 
>>> 5) If I will package UTF-8 I will need to invest time maintaining a new package that I do not care about and that contains just 4 headers files.
>>
>> I checked that there are at least 14 source packages in Debian that bundle UTF8-CPP:
>>
>> drizzle fife gdcm gource librime libvoikko love md5deep megaglest mkvtoolnix paraview ruby-passenger supertuxkart vtk
>>
>> Hopefully one of their maintainers would be interested in packaging it separately. Maybe file an RFP, CCing them all?
> 
> If you think it is useful, I will do this. However I would like to understand how I am supposed to deal with this kind of libraries before doing this.
> With the patch above, it will be very easy to use the system-wide utfcpp library once it is packaged.
> 
>>> Do you think that policy §4.13 apply in this case? I seems to me that it is more related to shared libraries than static ones and headers.
>>
>> No, §4.13 it's not only about shared library. It does apply here.
> 
> Ok, using libsparsehash-dev then.
> 
>>> Moreover I think that the last part of the following sentence applies:
>>> "Debian packages should not make use of these convenience copies unless the included package is explicitly intended to be used in this way".
>>
>> Do you have any evidence that this is the case (e.g. links to upstream documentation saying this is the preferred way of using the libraries)?
> 
> No, I have no evidence about it, but the documentation is scarce in this sense. Both libraries report something like:
> "You just need to put the .h files somewhere your compiler can see this."
> I just thought that sparsehash and utf8 are similar enough to gnulib that people would use them in the same way.
> 
>> FWIW, I'm personally not fond of this exception to §4.13. I think we would be better without it. Fixing autotools bugs is definitely not fun.
> 
> I see your point of view.
> But not being able to understand if autotools files are not working on others' systems because of different version of tools or because problems in the environment is also
> not fun. :-)
> 
>> Now the promised review of d/copyright:
>>
>>> Files: *
>>> Copyright: 2011-2012, Josef Robert Novak
>>> License: GPL-3+
>>
>> As far as I can see, the code has been relicensed to 2-clause BSD.
> 
> Right, fixed.
> 
>>> Files: debian/phonetisaurus-g2p.1
>>
>> No such file or directory.
> 
> Also fixed.
> 
>>> Files: FstPathFinder.cpp FstPathFinder.hpp
>>> Copyright: Chris Taylor
>>> 2011, Josef Novak
>>> License: Apache-2.0 and GPL-3+
>>
>> These now contain 2-clause BSD headers, though README.md says the "code was licensed under the Apache license". Could you clarify this with upstream?
> 
> This code is partially covered by Apache 2.0 license and partially by the BSD-2-clause license.
> Upstream tried to contact Chris Taylor in the past, but he was not able to talk to him.
> He is thinking about rewriting these files from scratch.
> 
>> Copyright/license information for src/3rdparty/google/ is missing.
> 
> Added.
> 
> Bests,
> 	Giulio.




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Mentors <debian-mentors@lists.debian.org>, Jakub Wilk <jwilk@debian.org>:
Bug#663916; Package sponsorship-requests. (Mon, 15 Oct 2012 21:09:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Giulio Paci <giuliopaci@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Mentors <debian-mentors@lists.debian.org>, Jakub Wilk <jwilk@debian.org>. (Mon, 15 Oct 2012 21:09:03 GMT) Full text and rfc822 format available.

Message #58 received at 663916@bugs.debian.org (full text, mbox):

From: Giulio Paci <giuliopaci@gmail.com>
To: 663916@bugs.debian.org
Subject: Re: Bug#663916: New phonetisaurus package available
Date: Mon, 15 Oct 2012 23:05:01 +0200
Hi!
	There has been a new phonetisaurus release (0.6).

All the patches have been applied upstream, the backup file in sparsehash has been removed, FstPathFinder.* have been rewritten from scratch.

I updated the Debian package files accordingly. All the phonetisaurus files have a BSD-2-clause header, but the README.txt reports BSD-3-clause. I will ask upstream about this.

Bests,
	Giulio.

Il 13/10/2012 15:54, Giulio Paci ha scritto:
> Hi!
> 	Thank you for your review.
> 
> Il 13/10/2012 00:02, Jakub Wilk ha scritto:
>> * Giulio Paci <giuliopaci@gmail.com>, 2012-10-11, 03:52:
>>>>> git://git.debian.org/git/collab-maint/phonetisaurus.git.
> 
>>>> Last but not least, why do you need to recover this file? It looks like it shouldn't have been included in the upstream tarball in the first place.
>>> Just because it was in the original tarball and I want that a "debian/rules clean" results in the same content of the original tarball.
>>
>> Now I seem to recall that you told me that your workflow depends on such restoration. Sorry for the noise.
> 
> No problem.
> 
>>>> Oh, and Google sparse hash implemented is already packaged in Debian. Please build-depend on libsparsehash-dev and make sure that the system-wide copy is used, not the
>>>> bundled one.
>>>>
>>>> Packaging the UTF-8 library (currently in src/3rdparty/utf8/) might be also worth considering, in order to comply with Policy §4.13.
>>>
>>> As we are not talking about shared libraries, but about a few headers files, I do not understand the benefits of doing so.
>>
>> The main benefit is the same: you can fix bugs in one place, instead of doing it N places (where N is usually >> 1).
> 
> Yes, I understand the goal, but I am worried that using external source code would make it harder to replicate possible issues (I will need the exact version of the
> libsparsehash-dev binary package that was used to compile the library).
> However this is probably true for many other C++ libraries. It is just more evident here, where the libraries are just simple header files.
> 
>>> I see only disadvantages:
>>> 1) using system wide files will prevent me to easily know the source code used to compile the phonetisaurus debian package;
>> (Sometimes we need to keep exact source for license reasons; that's what Built-Using field is for.)
> 
> How can I set Built-Using field? Should I set it by hand? Is it possible to set it automatically?
> 
>>> 2) fixes in sparsehash will not be available to phonetisaurus unless phonetisaurus is recompiled;
>>
>> That's not worse than status quo. Also: binNMUs are cheap.
> 
> Maybe I am missing something in the upload process (well, I am missing almost everything to be honest).
> Can you point some reference that will help me understanding what will happen when new releases of libsparsehash-dev will be released (and phonetisaurus will need
> recompilation)?
> 
>>> 3) I will need to maintain patches to use the system-wide copy;
> 
> Created, applied and forwarded a patch for this.
> 
>>> 4) an additional dependency is introduced;
>>
>> Again, convince upstream to drop the embedded copy, and these problems will go away. :)
> 
> Additional dependency introduced. :-) If the patch will be accepted upstream, the patch will let upstream to compile embedded copy of the libraries and us to compile using
> the system-wide dependency.
> 
>>> 5) If I will package UTF-8 I will need to invest time maintaining a new package that I do not care about and that contains just 4 headers files.
>>
>> I checked that there are at least 14 source packages in Debian that bundle UTF8-CPP:
>>
>> drizzle fife gdcm gource librime libvoikko love md5deep megaglest mkvtoolnix paraview ruby-passenger supertuxkart vtk
>>
>> Hopefully one of their maintainers would be interested in packaging it separately. Maybe file an RFP, CCing them all?
> 
> If you think it is useful, I will do this. However I would like to understand how I am supposed to deal with this kind of libraries before doing this.
> With the patch above, it will be very easy to use the system-wide utfcpp library once it is packaged.
> 
>>> Do you think that policy §4.13 apply in this case? I seems to me that it is more related to shared libraries than static ones and headers.
>>
>> No, §4.13 it's not only about shared library. It does apply here.
> 
> Ok, using libsparsehash-dev then.
> 
>>> Moreover I think that the last part of the following sentence applies:
>>> "Debian packages should not make use of these convenience copies unless the included package is explicitly intended to be used in this way".
>>
>> Do you have any evidence that this is the case (e.g. links to upstream documentation saying this is the preferred way of using the libraries)?
> 
> No, I have no evidence about it, but the documentation is scarce in this sense. Both libraries report something like:
> "You just need to put the .h files somewhere your compiler can see this."
> I just thought that sparsehash and utf8 are similar enough to gnulib that people would use them in the same way.
> 
>> FWIW, I'm personally not fond of this exception to §4.13. I think we would be better without it. Fixing autotools bugs is definitely not fun.
> 
> I see your point of view.
> But not being able to understand if autotools files are not working on others' systems because of different version of tools or because problems in the environment is also
> not fun. :-)
> 
>> Now the promised review of d/copyright:
>>
>>> Files: *
>>> Copyright: 2011-2012, Josef Robert Novak
>>> License: GPL-3+
>>
>> As far as I can see, the code has been relicensed to 2-clause BSD.
> 
> Right, fixed.
> 
>>> Files: debian/phonetisaurus-g2p.1
>>
>> No such file or directory.
> 
> Also fixed.
> 
>>> Files: FstPathFinder.cpp FstPathFinder.hpp
>>> Copyright: Chris Taylor
>>> 2011, Josef Novak
>>> License: Apache-2.0 and GPL-3+
>>
>> These now contain 2-clause BSD headers, though README.md says the "code was licensed under the Apache license". Could you clarify this with upstream?
> 
> This code is partially covered by Apache 2.0 license and partially by the BSD-2-clause license.
> Upstream tried to contact Chris Taylor in the past, but he was not able to talk to him.
> He is thinking about rewriting these files from scratch.
> 
>> Copyright/license information for src/3rdparty/google/ is missing.
> 
> Added.
> 
> Bests,
> 	Giulio.




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Mentors <debian-mentors@lists.debian.org>:
Bug#663916; Package sponsorship-requests. (Tue, 16 Oct 2012 15:15:03 GMT) Full text and rfc822 format available.

Message #61 received at 663916@bugs.debian.org (full text, mbox):

From: Jakub Wilk <jwilk@debian.org>
To: 663916@bugs.debian.org
Subject: Re: Bug#663916: New phonetisaurus package available
Date: Tue, 16 Oct 2012 17:12:18 +0200
* Giulio Paci <giuliopaci@gmail.com>, 2012-10-13, 15:54:
>How can I set Built-Using field? Should I set it by hand? Is it 
>possible to set it automatically?

Value of this field must be generated at build time. Unfortunately, 
there are currently no convenient tools to help you with this task; see 
bug #689062. In the mean time, you can take a look at how other packages 
do it:

$ grep-aptavail -F Built-Using . -s Source:Package -n | sort -u
binutils-mingw-w64 (2)
debian-installer (20120930)
debian-installer-netboot-images
gamera
gcc-mingw-w64 (7)
gdb-mingw-w64 (5)
mednafen
nvidia-graphics-modules (304.48+2)
win32-loader
xen

>Can you point some reference that will help me understanding what will 
>happen when new releases of libsparsehash-dev will be released (and 
>phonetisaurus will need recompilation)?

Nothing will happen automatically. But if someone (you, or sparsehash 
maintainer, or somebody else) decides it would be beneficial to rebuild 
phonetisaurus against new sparsehash, they can ask the Release Team to 
schedule binNMUs, i.e. recompilation without source changes. See also:
https://wiki.debian.org/binNMU


Now looking again at the copyright file:

>Files: src/3rdparty/utf8/* src/3rdparty/utf8.h

The directory has been renamed, please update it.

>License: MIT-like

The license UTF8-CPP uses is commonly know as Boost Software License, 
Version 1.0, so a short name like "BSL-1.0" or "Boost-1.0" might be 
better here.

>Files: src/3rdparty/google/*

This directory has been renamed, too.

-- 
Jakub Wilk



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Mentors <debian-mentors@lists.debian.org>, Jakub Wilk <jwilk@debian.org>:
Bug#663916; Package sponsorship-requests. (Tue, 16 Oct 2012 22:09:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Giulio Paci <giuliopaci@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Mentors <debian-mentors@lists.debian.org>, Jakub Wilk <jwilk@debian.org>. (Tue, 16 Oct 2012 22:09:03 GMT) Full text and rfc822 format available.

Message #66 received at 663916@bugs.debian.org (full text, mbox):

From: Giulio Paci <giuliopaci@gmail.com>
To: 663916@bugs.debian.org
Subject: Re: Bug#663916: New phonetisaurus package available
Date: Wed, 17 Oct 2012 00:05:02 +0200
Hi!

Il 16/10/2012 17:12, Jakub Wilk ha scritto:
> * Giulio Paci <giuliopaci@gmail.com>, 2012-10-13, 15:54:
>> How can I set Built-Using field? Should I set it by hand? Is it possible to set it automatically?
> 
> Value of this field must be generated at build time. Unfortunately, there are currently no convenient tools to help you with this task; see bug #689062. In the mean time,
> you can take a look at how other packages do it:
> 
> $ grep-aptavail -F Built-Using . -s Source:Package -n | sort -u
> binutils-mingw-w64 (2)
> debian-installer (20120930)
> debian-installer-netboot-images
> gamera
> gcc-mingw-w64 (7)
> gdb-mingw-w64 (5)
> mednafen
> nvidia-graphics-modules (304.48+2)
> win32-loader
> xen

Thank you very much. I read the bug thread and I added a Built-Using field (I used mednafen as a base).

I just tried to collect the list of maintainers for the package that you suggested are using utf8-cpp (drizzle fife gdcm gource librime libvoikko love md5deep megaglest
mkvtoolnix paraview ruby-passenger supertuxkart vtk), however I have problems obtaining the list:
The following command:

for i in drizzle fife gdcm gource librime libvoikko love md5deep megaglest mkvtoolnix paraview ruby-passenger supertuxkart vtk; do echo $i; LANG=C apt-cache show $i | grep
Maintainer; done

On my system results in:

drizzle
Maintainer: Tobias Frost <tobi@coldtobi.de>
Maintainer: Tobias Frost <tobi@coldtobi.de>
fife
E: No packages found
gdcm
E: No packages found
gource
Maintainer: Andrew Caudwell <acaudwell@gmail.com>
librime
E: No packages found
libvoikko
E: No packages found
love
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
md5deep
Maintainer: Debian Forensics <forensics-devel@lists.alioth.debian.org>
megaglest
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
mkvtoolnix
Maintainer: Christian Marillat <marillat@debian.org>
paraview
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
ruby-passenger
Maintainer: Debian Ruby Extras Maintainers <pkg-ruby-extras-maintainers@lists.alioth.debian.org>
supertuxkart
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
vtk

How did you get the list? fife, gdcm, librime and libvoikko seem not to exist, while vtk seems to be a virtual package.

>> Can you point some reference that will help me understanding what will happen when new releases of libsparsehash-dev will be released (and phonetisaurus will need
>> recompilation)?
> 
> Nothing will happen automatically. But if someone (you, or sparsehash maintainer, or somebody else) decides it would be beneficial to rebuild phonetisaurus against new
> sparsehash, they can ask the Release Team to schedule binNMUs, i.e. recompilation without source changes. See also:
> https://wiki.debian.org/binNMU

I read this quickly. But it starts being more clear to me.

> Now looking again at the copyright file:
> 
>> Files: src/3rdparty/utf8/* src/3rdparty/utf8.h
> 
> The directory has been renamed, please update it.

Fixed.

>> License: MIT-like
> 
> The license UTF8-CPP uses is commonly know as Boost Software License, Version 1.0, so a short name like "BSL-1.0" or "Boost-1.0" might be better here.

I chose "Boost-1.0".

>> Files: src/3rdparty/google/*
> 
> This directory has been renamed, too.

Fixed.

Bests,
	Giulio.



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Mentors <debian-mentors@lists.debian.org>:
Bug#663916; Package sponsorship-requests. (Wed, 17 Oct 2012 14:21:09 GMT) Full text and rfc822 format available.

Message #69 received at 663916@bugs.debian.org (full text, mbox):

From: Jakub Wilk <jwilk@debian.org>
To: 663916@bugs.debian.org
Subject: Re: Bug#663916: New phonetisaurus package available
Date: Wed, 17 Oct 2012 16:19:40 +0200
* Giulio Paci <giuliopaci@gmail.com>, 2012-10-17, 00:05:
>>>How can I set Built-Using field? Should I set it by hand? Is it 
>>>possible to set it automatically?
>>Value of this field must be generated at build time. Unfortunately, 
>>there are currently no convenient tools to help you with this task; 
>>see bug #689062.
[...]
>Thank you very much. I read the bug thread and I added a Built-Using 
>field (I used mednafen as a base).

It looks good. Support for ${source:Package} and ${source:Version} 
variables was added to dpkg in 1.16.2, so please bump the version in 
Build-Depends.

>I just tried to collect the list of maintainers for the package that 
>you suggested are using utf8-cpp (drizzle fife gdcm gource librime 
>libvoikko love md5deep megaglest mkvtoolnix paraview ruby-passenger 
>supertuxkart vtk), however I have problems obtaining the list:
>The following command:
>
>for i in drizzle fife gdcm gource librime libvoikko love md5deep megaglest mkvtoolnix paraview ruby-passenger supertuxkart vtk; do echo $i; LANG=C apt-cache show $i | grep
>Maintainer; done
[...]
>How did you get the list?

http://http.debian.net/debian/dists/unstable/main/Contents-source.gz is 
an index of files in all source packages. IIRC I searched for 
"/unchecked.h" and then manually filter out false-positives. (I was told 
that you can also use apt-file to search through these files.)

>fife, gdcm, librime and libvoikko seem not to 
>exist, while vtk seems to be a virtual package.

These were source package names, not binary package names. 
s/show/showsrc/ should help. :) There's also a dedicated tool to make 
lists of package maintainers: dd-list in devscripts.

>>>Files: src/3rdparty/utf8/* src/3rdparty/utf8.h
>>The directory has been renamed, please update it.
>Fixed.

Now it's:

Files: src/3rdparty/utfcpp/utf8/* src/3rdparty/utfcpp/utf8.h

which is okay, but since there are no other files in the utfcpp/ 
subdirectory, it could be simplified to:

Files: src/3rdparty/utfcpp/*

-- 
Jakub Wilk



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Mentors <debian-mentors@lists.debian.org>, Jakub Wilk <jwilk@debian.org>:
Bug#663916; Package sponsorship-requests. (Fri, 19 Oct 2012 22:03:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Giulio Paci <giuliopaci@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Mentors <debian-mentors@lists.debian.org>, Jakub Wilk <jwilk@debian.org>. (Fri, 19 Oct 2012 22:03:03 GMT) Full text and rfc822 format available.

Message #74 received at 663916@bugs.debian.org (full text, mbox):

From: Giulio Paci <giuliopaci@gmail.com>
To: 663916@bugs.debian.org
Subject: Re: Bug#663916: New phonetisaurus package available
Date: Sat, 20 Oct 2012 00:00:31 +0200
Hi!

Il 17/10/2012 16:19, Jakub Wilk ha scritto:
> * Giulio Paci <giuliopaci@gmail.com>, 2012-10-17, 00:05:
>>>> How can I set Built-Using field? Should I set it by hand? Is it possible to set it automatically?
>>> Value of this field must be generated at build time. Unfortunately, there are currently no convenient tools to help you with this task; see bug #689062.
> [...]
>> Thank you very much. I read the bug thread and I added a Built-Using field (I used mednafen as a base).
> 
> It looks good. Support for ${source:Package} and ${source:Version} variables was added to dpkg in 1.16.2, so please bump the version in Build-Depends.

Bumped.

>> I just tried to collect the list of maintainers for the package that you suggested are using utf8-cpp (drizzle fife gdcm gource librime libvoikko love md5deep megaglest
>> mkvtoolnix paraview ruby-passenger supertuxkart vtk), however I have problems obtaining the list:
>> The following command:
>>
>> for i in drizzle fife gdcm gource librime libvoikko love md5deep megaglest mkvtoolnix paraview ruby-passenger supertuxkart vtk; do echo $i; LANG=C apt-cache show $i | grep
>> Maintainer; done
> [...]
>> How did you get the list?
> 
> http://http.debian.net/debian/dists/unstable/main/Contents-source.gz is an index of files in all source packages. IIRC I searched for "/unchecked.h" and then manually
> filter out false-positives. (I was told that you can also use apt-file to search through these files.)

Thank you very much, this file will make my life easier.

>> fife, gdcm, librime and libvoikko seem not to exist, while vtk seems to be a virtual package.
> 
> These were source package names, not binary package names. s/show/showsrc/ should help. :) There's also a dedicated tool to make lists of package maintainers: dd-list in
> devscripts.

And this command even more. :-)

I just had a look to the already opened bugs and I found that there is an RFP bug for utfcpp:
http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=552618

Do you think I should do anything else (e.g., reply to the bug with the maintainers of the packages you identified in CC)?

> Files: src/3rdparty/utfcpp/utf8/* src/3rdparty/utfcpp/utf8.h
> 
> could be simplified to:
> 
> Files: src/3rdparty/utfcpp/*

Done.

Bests,
	Giulio.



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Mentors <debian-mentors@lists.debian.org>:
Bug#663916; Package sponsorship-requests. (Sat, 20 Oct 2012 20:57:06 GMT) Full text and rfc822 format available.

Message #77 received at 663916@bugs.debian.org (full text, mbox):

From: Jakub Wilk <jwilk@debian.org>
To: 663916@bugs.debian.org
Subject: Re: Bug#663916: New phonetisaurus package available
Date: Sat, 20 Oct 2012 22:55:26 +0200
* Giulio Paci <giuliopaci@gmail.com>, 2012-10-20, 00:00:
>I just had a look to the already opened bugs and I found that there is 
>an RFP bug for utfcpp:
>http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=552618
>
>Do you think I should do anything else (e.g., reply to the bug with the 
>maintainers of the packages you identified in CC)?

I think reply+cc would be a good idea, but I won't insist.

If I run phonetisaurus-align without arguments, it segfaults:
| $ phonetisaurus-align
| Loading input file:
| Starting EM...
| Finished first iter...
| Iteration: 1 Change: nan
| Iteration: 2 Change: nan
| Iteration: 3 Change: nan
| Iteration: 4 Change: nan
| Iteration: 5 Change: nan
| Iteration: 6 Change: nan
| Iteration: 7 Change: nan
| Iteration: 8 Change: nan
| Iteration: 9 Change: nan
| Iteration: 10 Change: nan
| Iteration: 11 Change: nan
| Last iteration:
| Segmentation fault

The manpage seems to imply that --input and --ofile options are 
mandatory, so I'm not sure what it is even trying to do... But it 
certainly shouldn't segfault.

Shouldn't phonetisaurus-align input format be documented somewhere? BTW, 
it aborts without any helpful error message if the input file is not 
valid:
| $ echo foobar > invalid.txt
| $ phonetisaurus-align --input=invalid.txt --ofile=invalid.corpus
| Loading input file: tiny.bsf
| terminate called after throwing an instance of 'std::out_of_range'
|   what():  vector::_M_range_check
| Aborted

What does --fst_field_separator exactly do? In my experiments it did not 
affect phonetisaurus-align in any way.

-- 
Jakub Wilk



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Mentors <debian-mentors@lists.debian.org>, Jakub Wilk <jwilk@debian.org>:
Bug#663916; Package sponsorship-requests. (Sun, 21 Oct 2012 02:42:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Giulio Paci <giuliopaci@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Mentors <debian-mentors@lists.debian.org>, Jakub Wilk <jwilk@debian.org>. (Sun, 21 Oct 2012 02:42:03 GMT) Full text and rfc822 format available.

Message #82 received at 663916@bugs.debian.org (full text, mbox):

From: Giulio Paci <giuliopaci@gmail.com>
To: 663916@bugs.debian.org
Subject: Re: Bug#663916: New phonetisaurus package available
Date: Sun, 21 Oct 2012 04:39:47 +0200
Il 20/10/2012 22:55, Jakub Wilk ha scritto:
> * Giulio Paci <giuliopaci@gmail.com>, 2012-10-20, 00:00:
>> I just had a look to the already opened bugs and I found that there is an RFP bug for utfcpp:
>> http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=552618
>>
>> Do you think I should do anything else (e.g., reply to the bug with the maintainers of the packages you identified in CC)?
> 
> I think reply+cc would be a good idea, but I won't insist.

Done.

> If I run phonetisaurus-align without arguments, it segfaults:
> | $ phonetisaurus-align
> | Loading input file:
> | Starting EM...
> | Finished first iter...
> | Iteration: 1 Change: nan
> | Iteration: 2 Change: nan
> | Iteration: 3 Change: nan
> | Iteration: 4 Change: nan
> | Iteration: 5 Change: nan
> | Iteration: 6 Change: nan
> | Iteration: 7 Change: nan
> | Iteration: 8 Change: nan
> | Iteration: 9 Change: nan
> | Iteration: 10 Change: nan
> | Iteration: 11 Change: nan
> | Last iteration:
> | Segmentation fault
> 
> The manpage seems to imply that --input and --ofile options are mandatory, so I'm not sure what it is even trying to do... But it certainly shouldn't segfault.

--input is mandatory indeed. I added a patch to prevent segfaults. The message is not very clear, but I hope is enugh.

> Shouldn't phonetisaurus-align input format be documented somewhere? BTW, it aborts without any helpful error message if the input file is not valid:
> | $ echo foobar > invalid.txt
> | $ phonetisaurus-align --input=invalid.txt --ofile=invalid.corpus
> | Loading input file: tiny.bsf
> | terminate called after throwing an instance of 'std::out_of_range'
> |   what():  vector::_M_range_check
> | Aborted

I documented the format in the manpage. The input format is very generic and it would be probably difficult to detect invalid input files.
The error above is because the program expects a two columns file and only one column was provided. Now this error is not reported anymore (in my opinion one column files
are still valid input, but I am waiting confirm from upstream).

> What does --fst_field_separator exactly do? In my experiments it did not affect phonetisaurus-align in any way.

Unfortunately I do not know most of the options of this program. I asked upstream about this option.

Bests,
	Giulio.



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Mentors <debian-mentors@lists.debian.org>, Jakub Wilk <jwilk@debian.org>:
Bug#663916; Package sponsorship-requests. (Sun, 21 Oct 2012 13:09:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Giulio Paci <giuliopaci@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Mentors <debian-mentors@lists.debian.org>, Jakub Wilk <jwilk@debian.org>. (Sun, 21 Oct 2012 13:09:03 GMT) Full text and rfc822 format available.

Message #87 received at 663916@bugs.debian.org (full text, mbox):

From: Giulio Paci <giuliopaci@gmail.com>
To: 663916@bugs.debian.org
Subject: Re: Bug#663916: New phonetisaurus package available
Date: Sun, 21 Oct 2012 15:04:32 +0200
Il 21/10/2012 04:39, Giulio Paci ha scritto:
> Il 20/10/2012 22:55, Jakub Wilk ha scritto:
>> What does --fst_field_separator exactly do? In my experiments it did not affect phonetisaurus-align in any way.
> 
> Unfortunately I do not know most of the options of this program. I asked upstream about this option.

Upstream replied that these flags are automatically added by openfst:
http://www.openfst.org/twiki/bin/view/FST/FstAdvancedUsage#Command_Line_Flags
Some of them affect the behaviour of functions that are not used by phonetisaurus-align.
However he does not know how to hide those inherited options (and I do not know as well) without rewriting all the flags parsing code.
Do you know how to hide them? Is it mandatory to identify "possibly useless" flags and to hide them?

Bests,
	Giulio.



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Mentors <debian-mentors@lists.debian.org>:
Bug#663916; Package sponsorship-requests. (Mon, 22 Oct 2012 15:51:06 GMT) Full text and rfc822 format available.

Message #90 received at 663916@bugs.debian.org (full text, mbox):

From: Jakub Wilk <jwilk@debian.org>
To: 663916@bugs.debian.org
Subject: Re: Bug#663916: New phonetisaurus package available
Date: Mon, 22 Oct 2012 17:48:09 +0200
* Giulio Paci <giuliopaci@gmail.com>, 2012-10-21, 15:04:
>>>What does --fst_field_separator exactly do? In my experiments it did 
>>>not affect phonetisaurus-align in any way.
>>Unfortunately I do not know most of the options of this program. I 
>>asked upstream about this option.
>Upstream replied that these flags are automatically added by openfst:
>http://www.openfst.org/twiki/bin/view/FST/FstAdvancedUsage#Command_Line_Flags
>Some of them affect the behaviour of functions that are not used by 
>phonetisaurus-align.
>However he does not know how to hide those inherited options (and I do 
>not know as well) without rewriting all the flags parsing code.
>Do you know how to hide them?

No idea, sorry.

>Is it mandatory to identify "possibly useless" flags and to hide them?

I understand that removing/hiding unneeded option might be infeasible, 
but I would expect that these no-ops are documented as such in the 
manual page (or alternative: that they are not documented in the manpage 
at at all).

There are some warnings in the build log:
| /usr/bin/make  -C src CFLAGS="-g -O2 -fPIE -fstack-protector --param=ssp-buffer-size=4 -Wformat -Werror=format-security -Wall" CXXFLAGS="-g -O2 -fPIE -fstack-protector --param=ssp-buffer-size=4 -Wformat -Werror=format-security" CPPFLAGS="-D_FORTIFY_SOURCE=2" LDFLAGS="-fPIE -pie -Wl,-z,relro -Wl,-z,now"  THIRD_PARTIES_INCLUDE="-I3rdparty/utfcpp" -k clean
| make[1]: Entering directory `/build/phonetisaurus-DN3moq/phonetisaurus-0.6/src'
| rm ../phonetisaurus-g2p ../phonetisaurus-align ../phonetisaurus-arpa2fst *.o
| rm: cannot remove `../phonetisaurus-g2p': No such file or directory
| rm: cannot remove `../phonetisaurus-align': No such file or directory
| rm: cannot remove `../phonetisaurus-arpa2fst': No such file or directory
| rm: cannot remove `*.o': No such file or directory
| make[1]: *** [clean] Error 1
| make[1]: Leaving directory `/build/phonetisaurus-DN3moq/phonetisaurus-0.6/src'
| make: [makefile-clean] Error 2 (ignored)

The above indicates two problem:
1) Upstream "make clean" is not idempotent: it fails it there's nothing 
to clean. Replacing "rm" with "rm -f" should fix this issue.
2) cdbs doesn't ignore errors from "make clean". This was reported in 
#441020 over 5 years ago. (Sigh...)

There's a warning about debian/copyright_hints not being up-to-date.

There's also a few dozens of compiler warnings. Is upstream aware of 
them?

-- 
Jakub Wilk



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Mentors <debian-mentors@lists.debian.org>, Jakub Wilk <jwilk@debian.org>:
Bug#663916; Package sponsorship-requests. (Mon, 22 Oct 2012 21:57:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Giulio Paci <giuliopaci@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Mentors <debian-mentors@lists.debian.org>, Jakub Wilk <jwilk@debian.org>. (Mon, 22 Oct 2012 21:57:05 GMT) Full text and rfc822 format available.

Message #95 received at 663916@bugs.debian.org (full text, mbox):

From: Giulio Paci <giuliopaci@gmail.com>
To: 663916@bugs.debian.org
Subject: Re: Bug#663916: New phonetisaurus package available
Date: Mon, 22 Oct 2012 23:55:30 +0200
Il 22/10/2012 17:48, Jakub Wilk ha scritto:
> * Giulio Paci <giuliopaci@gmail.com>, 2012-10-21, 15:04:
>> Is it mandatory to identify "possibly useless" flags and to hide them?
> 
> I understand that removing/hiding unneeded option might be infeasible, but I would expect that these no-ops are documented as such in the manual page (or alternative: that
> they are not documented in the manpage at at all).

Removed those flags from the manpages.

> 1) Upstream "make clean" is not idempotent: it fails it there's nothing to clean. Replacing "rm" with "rm -f" should fix this issue.

Fixed by using $(RM).

> There's a warning about debian/copyright_hints not being up-to-date.

Fixed.

> There's also a few dozens of compiler warnings. Is upstream aware of them?

I just sent an email about them, along with a patch removing most of them. I left untouched those warnings that I was not sure how to solve properly. I am waiting upstream
to solve them.

Bests,
	Giulio.






Information forwarded to debian-bugs-dist@lists.debian.org, Debian Mentors <debian-mentors@lists.debian.org>, Jakub Wilk <jwilk@debian.org>:
Bug#663916; Package sponsorship-requests. (Mon, 22 Oct 2012 22:27:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Giulio Paci <giuliopaci@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Mentors <debian-mentors@lists.debian.org>, Jakub Wilk <jwilk@debian.org>. (Mon, 22 Oct 2012 22:27:03 GMT) Full text and rfc822 format available.

Message #100 received at 663916@bugs.debian.org (full text, mbox):

From: Giulio Paci <giuliopaci@gmail.com>
To: 663916@bugs.debian.org
Subject: Re: Bug#663916: New phonetisaurus package available
Date: Tue, 23 Oct 2012 00:24:45 +0200
Errata corrige.

Il 22/10/2012 23:55, Giulio Paci ha scritto:
> Il 22/10/2012 17:48, Jakub Wilk ha scritto:
>> * Giulio Paci <giuliopaci@gmail.com>, 2012-10-21, 15:04:
>>> Is it mandatory to identify "possibly useless" flags and to hide them?
>>
>> I understand that removing/hiding unneeded option might be infeasible, but I would expect that these no-ops are documented as such in the manual page (or alternative: that
>> they are not documented in the manpage at at all).
> 
> Removed those flags from the manpages.
> 
>> 1) Upstream "make clean" is not idempotent: it fails it there's nothing to clean. Replacing "rm" with "rm -f" should fix this issue.
> 
> Fixed by using $(RM).

>> 2) cdbs doesn't ignore errors from "make clean". This was reported in #441020 over 5 years ago. (Sigh...) 

I just read the bug report. Actually cdbs ignores errors in "make clean".
So the problem here seems to be that building should fail on "make clean", but it was working anyway. Right?

>> There's a warning about debian/copyright_hints not being up-to-date.
> 
> Fixed.

I re-created the problem by adding the new patch. Now it is fixed (again).

>> There's also a few dozens of compiler warnings. Is upstream aware of them?
> 
> I just sent an email about them, along with a patch removing most of them. I left untouched those warnings that I was not sure how to solve properly. I am waiting upstream
> to solve them.

The patch header was broken, I fixed it.

Bests,
	Giulio.



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Mentors <debian-mentors@lists.debian.org>:
Bug#663916; Package sponsorship-requests. (Mon, 22 Oct 2012 22:39:03 GMT) Full text and rfc822 format available.

Message #103 received at 663916@bugs.debian.org (full text, mbox):

From: Jakub Wilk <jwilk@debian.org>
To: 663916@bugs.debian.org
Subject: Re: Bug#663916: New phonetisaurus package available
Date: Tue, 23 Oct 2012 00:37:16 +0200
* Giulio Paci <giuliopaci@gmail.com>, 2012-10-23, 00:24:
>>>2) cdbs doesn't ignore errors from "make clean". This was reported in 
>>>#441020 over 5 years ago. (Sigh...)
>
>I just read the bug report. Actually cdbs ignores errors in "make clean".
>So the problem here seems to be that building should fail on "make 
>clean", but it was working anyway. Right?

D'oh! I meant s/doesn't/shouldn't/. So yes, you are right. Sorry for the 
confusion.

-- 
Jakub Wilk



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Mentors <debian-mentors@lists.debian.org>:
Bug#663916; Package sponsorship-requests. (Tue, 23 Oct 2012 19:39:03 GMT) Full text and rfc822 format available.

Message #106 received at 663916@bugs.debian.org (full text, mbox):

From: Jakub Wilk <jwilk@debian.org>
To: 663916@bugs.debian.org
Subject: Re: Bug#663916: New phonetisaurus package available
Date: Tue, 23 Oct 2012 21:36:38 +0200
* Giulio Paci <giuliopaci@gmail.com>, 2012-10-22, 23:55:
>>There's also a few dozens of compiler warnings. Is upstream aware of 
>>them?
>I just sent an email about them, along with a patch removing most of 
>them.

I think "fix" would be a better verb than "remove" here (in the patch 
name and its description).

-- 
Jakub Wilk



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Mentors <debian-mentors@lists.debian.org>, Jakub Wilk <jwilk@debian.org>:
Bug#663916; Package sponsorship-requests. (Tue, 23 Oct 2012 22:09:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Giulio Paci <giuliopaci@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Mentors <debian-mentors@lists.debian.org>, Jakub Wilk <jwilk@debian.org>. (Tue, 23 Oct 2012 22:09:03 GMT) Full text and rfc822 format available.

Message #111 received at 663916@bugs.debian.org (full text, mbox):

From: Giulio Paci <giuliopaci@gmail.com>
To: 663916@bugs.debian.org
Subject: Re: Bug#663916: New phonetisaurus package available
Date: Wed, 24 Oct 2012 00:07:23 +0200
Il 23/10/2012 21:36, Jakub Wilk ha scritto:
> * Giulio Paci <giuliopaci@gmail.com>, 2012-10-22, 23:55:
>>> There's also a few dozens of compiler warnings. Is upstream aware of them?
>> I just sent an email about them, along with a patch removing most of them.
> 
> I think "fix" would be a better verb than "remove" here (in the patch name and its description).

You are right. Fixed. ;-)



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Mentors <debian-mentors@lists.debian.org>:
Bug#663916; Package sponsorship-requests. (Wed, 24 Oct 2012 15:00:03 GMT) Full text and rfc822 format available.

Message #114 received at 663916@bugs.debian.org (full text, mbox):

From: Jakub Wilk <jwilk@debian.org>
To: 663916@bugs.debian.org
Subject: Re: Bug#663916: New phonetisaurus package available
Date: Wed, 24 Oct 2012 16:56:07 +0200
* Giulio Paci <giuliopaci@gmail.com>, 2012-10-22, 23:55:
>>1) Upstream "make clean" is not idempotent: it fails it there's 
>>nothing to clean. Replacing "rm" with "rm -f" should fix this issue.
>Fixed by using $(RM).

This fix appears to be part of 1002_remove_some_warnings.patch. Could 
you move it into a separate patch?

Please also bump date in the changelog.

-- 
Jakub Wilk



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Mentors <debian-mentors@lists.debian.org>, Jakub Wilk <jwilk@debian.org>:
Bug#663916; Package sponsorship-requests. (Wed, 24 Oct 2012 18:39:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Giulio Paci <giuliopaci@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Mentors <debian-mentors@lists.debian.org>, Jakub Wilk <jwilk@debian.org>. (Wed, 24 Oct 2012 18:39:06 GMT) Full text and rfc822 format available.

Message #119 received at 663916@bugs.debian.org (full text, mbox):

From: Giulio Paci <giuliopaci@gmail.com>
To: 663916@bugs.debian.org
Subject: Re: Bug#663916: New phonetisaurus package available
Date: Wed, 24 Oct 2012 20:36:08 +0200
Il 24/10/2012 16:56, Jakub Wilk ha scritto:
> * Giulio Paci <giuliopaci@gmail.com>, 2012-10-22, 23:55:
>>> 1) Upstream "make clean" is not idempotent: it fails it there's nothing to clean. Replacing "rm" with "rm -f" should fix this issue.
>> Fixed by using $(RM).
> 
> This fix appears to be part of 1002_remove_some_warnings.patch. Could you move it into a separate patch?

Done.

> Please also bump date in the changelog.

Done.



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Mentors <debian-mentors@lists.debian.org>:
Bug#663916; Package sponsorship-requests. (Thu, 25 Oct 2012 13:39:05 GMT) Full text and rfc822 format available.

Message #122 received at 663916@bugs.debian.org (full text, mbox):

From: Jakub Wilk <jwilk@debian.org>
To: 663916@bugs.debian.org
Subject: Re: Bug#663916: New phonetisaurus package available
Date: Thu, 25 Oct 2012 15:37:41 +0200
Please bump Standards-Version to 3.9.4. (But note that lintian isn't 
aware of it yet, so you'll get a spurious newer-standards-version, which 
you should ignore for the time being.)

Would it be possible to enable parallel builds?

g2p segfaults if the model doesn't exist:

$ phonetisaurus-g2p --model=/nonexistent
ERROR: ExpandedFst::Read: Can't open file: /nonexistent
Segmentation fault

debian/copyright_hints are out-of-date again. :)

The copyright file says:

Files: src/3rdparty/sparsehash/google/*
Copyright: 2005-2007, Google Inc.

but one of the files has this notice:

// Copyright (c) 2010, Google Inc.

-- 
Jakub Wilk



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Mentors <debian-mentors@lists.debian.org>, Jakub Wilk <jwilk@debian.org>:
Bug#663916; Package sponsorship-requests. (Sat, 27 Oct 2012 15:33:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to Giulio Paci <giuliopaci@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Mentors <debian-mentors@lists.debian.org>, Jakub Wilk <jwilk@debian.org>. (Sat, 27 Oct 2012 15:33:09 GMT) Full text and rfc822 format available.

Message #127 received at 663916@bugs.debian.org (full text, mbox):

From: Giulio Paci <giuliopaci@gmail.com>
To: 663916@bugs.debian.org
Subject: Re: Bug#663916: New phonetisaurus package available
Date: Sat, 27 Oct 2012 17:32:29 +0200
Il 25/10/2012 15:37, Jakub Wilk ha scritto:
> Please bump Standards-Version to 3.9.4. (But note that lintian isn't aware of it yet, so you'll get a spurious newer-standards-version, which you should ignore for the time
> being.)

Done.

> Would it be possible to enable parallel builds?

Done.

> g2p segfaults if the model doesn't exist:
> 
> $ phonetisaurus-g2p --model=/nonexistent
> ERROR: ExpandedFst::Read: Can't open file: /nonexistent
> Segmentation fault

Fixed.

> debian/copyright_hints are out-of-date again. :)

Fixed again... :-)

> The copyright file says:
> 
> Files: src/3rdparty/sparsehash/google/*
> Copyright: 2005-2007, Google Inc.
> 
> but one of the files has this notice:
> 
> // Copyright (c) 2010, Google Inc.

Fixed.

Bests,
	Giulio.




Reply sent to Jakub Wilk <jwilk@debian.org>:
You have taken responsibility. (Sat, 27 Oct 2012 17:48:08 GMT) Full text and rfc822 format available.

Notification sent to Giulio Paci <giuliopaci@gmail.com>:
Bug acknowledged by developer. (Sat, 27 Oct 2012 17:48:08 GMT) Full text and rfc822 format available.

Message #132 received at 663916-done@bugs.debian.org (full text, mbox):

From: Jakub Wilk <jwilk@debian.org>
To: 663916-done@bugs.debian.org
Subject: Re: Bug#663916: New phonetisaurus package available
Date: Sat, 27 Oct 2012 19:46:42 +0200
Uploaded.

-- 
Jakub Wilk



Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Sun, 25 Nov 2012 07:26:02 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 17 16:34:53 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.